#ifndef TARANTOOL_CONFIG_H_INCLUDED
#define TARANTOOL_CONFIG_H_INCLUDED
/*
 * This file is generated by CMake. The original file is called
 * config.h.cmake. Please do not modify.
 */
/** \cond public */

/**
 * Package major version - 1 for 1.6.7
 */
#define PACKAGE_VERSION_MAJOR 2
/**
 * Package minor version - 6 for 1.6.7
 */
#define PACKAGE_VERSION_MINOR 11
/**
 * Package patch version - 7 for 1.6.7
 */
#define PACKAGE_VERSION_PATCH 2
/**
 * A string with major-minor-patch-commit-id identifier of the
 * release, e.g. 1.6.6-113-g8399d0e.
 */
#define PACKAGE_VERSION "2.11.2-145-gf47af793d"

/** \endcond public */

#define PACKAGE "Tarantool"
/* Defined to 1 if building for Linux, or to 0 otherwise. */
#define TARGET_OS_LINUX 0
/* Defined to 1 if building for FreeBSD, or to 0 otherwise. */
#define TARGET_OS_FREEBSD 0
/* Defined to 1 if building for NetBSD, or to 0 otherwise. */
#define TARGET_OS_NETBSD 0
/* Defined to 1 if building for Darwin, or to 0 otherwise. */
#define TARGET_OS_DARWIN 1

#if TARGET_OS_DARWIN
#define TARANTOOL_LIBEXT "dylib"
#else
#define TARANTOOL_LIBEXT "so"
#endif

/**
 * Defined if cpuid() instruction is available.
 */
/* #undef HAVE_CPUID */

/**
 * Defined if strlcpy() string extension helper present.
 */
#define HAVE_STRLCPY 1

/**
 * Defined if strlcat() string extension helper present.
 */
#define HAVE_STRLCAT 1

/**
 * Defined if this platform has GNU specific strerror_r().
 */
/* #undef HAVE_STRERROR_R_GNU */

/*
 * Defined if gcov instrumentation should be enabled.
 */
/* #undef ENABLE_GCOV */
/*
 * Defined if configured with ENABLE_BACKTRACE ('show fiber'
 * showing fiber call stack.
 */
#define ENABLE_BACKTRACE 1
/*
 * Defined if configured with ABORT_ON_LEAK.
 */
/* #undef ABORT_ON_LEAK */
/*
 * Defined if configured with JIT engine turned on.
 */
/* #undef LUAJIT_JIT_STATUS */

/*
 * Set if the system has bfd.h header and GNU bfd library.
 */
/* #undef HAVE_BFD */
#define HAVE_MAP_ANON 1
#define HAVE_MAP_ANONYMOUS 1
#if !defined(HAVE_MAP_ANONYMOUS) && defined(HAVE_MAP_ANON)
/*
 * MAP_ANON is deprecated, MAP_ANONYMOUS should be used instead.
 * Unfortunately, it's not universally present (e.g. not present
 * on FreeBSD.
 */
#define MAP_ANONYMOUS MAP_ANON
#endif
#define HAVE_MADV_DONTNEED 1
/*
 * Defined if O_DSYNC mode exists for open(2).
 */
#define HAVE_O_DSYNC 1
#if defined(HAVE_O_DSYNC)
    #define WAL_SYNC_FLAG O_DSYNC
#else
    #define WAL_SYNC_FLAG O_SYNC
#endif
/*
 * Defined if fdatasync(2) call is present.
 */
/* #undef HAVE_FDATASYNC */

#ifndef HAVE_FDATASYNC
#if defined(__APPLE__)
#include <fcntl.h>
#define fdatasync(fd) fcntl(fd, F_FULLFSYNC)
#else
#define fdatasync fsync
#endif
#endif

/*
 * Defined if this platform has GNU specific memmem().
 */
#define HAVE_MEMMEM 1
/*
 * Defined if this platform has GNU specific memrchr().
 */
/* #undef HAVE_MEMRCHR */
/*
 * Defined if this platform has sendfile(..).
 */
#define HAVE_SENDFILE 1
/*
 * Defined if this platform has Linux specific sendfile(..).
 */
/* #undef HAVE_SENDFILE_LINUX */
/*
 * Defined if this platform has BSD specific sendfile(..).
 */
#define HAVE_SENDFILE_BSD 1
/*
 * Set if this is a GNU system and libc has __libc_stack_end.
 */
/* #undef HAVE_LIBC_STACK_END */
/*
 * Defined if this is a big-endian system.
 */
/* #undef HAVE_BYTE_ORDER_BIG_ENDIAN */
/*
*  Defined if compatible with GNU readline installed.
*/
#define HAVE_GNU_READLINE 1

/*
 * Defined if `st_mtim' is a member of `struct stat'.
 */
/* #undef HAVE_STRUCT_STAT_ST_MTIM */

/*
 * Defined if `st_mtimensec' is a member of `struct stat'.
 */
/* #undef HAVE_STRUCT_STAT_ST_MTIMENSEC */

/*
 * Set if compiler has __builtin_XXX methods.
 */
#define HAVE_BUILTIN_CTZ 1
#define HAVE_BUILTIN_CTZLL 1
#define HAVE_BUILTIN_CLZ 1
#define HAVE_BUILTIN_CLZLL 1
#define HAVE_BUILTIN_POPCOUNT 1
#define HAVE_BUILTIN_POPCOUNTLL 1
#define HAVE_BUILTIN_BSWAP32 1
#define HAVE_BUILTIN_BSWAP64 1
/* #undef HAVE_FFSL */
/* #undef HAVE_FFSLL */

/*
 * pthread have problems with -std=c99
 */
/* #undef HAVE_NON_C99_PTHREAD_H */

#define ENABLE_BUNDLED_LIBEV 1
#define ENABLE_BUNDLED_LIBEIO 1
#define ENABLE_BUNDLED_LIBCORO 1

/* #undef HAVE_PTHREAD_YIELD */
#define HAVE_SCHED_YIELD 1
/* #undef HAVE_POSIX_FADVISE */
/* #undef HAVE_FALLOCATE */
/* #undef HAVE_MREMAP */
/* #undef HAVE_SYNC_FILE_RANGE */

#define HAVE_MSG_NOSIGNAL 1
#define HAVE_SO_NOSIGPIPE 1

/* #undef HAVE_PRCTL_H */

/* #undef HAVE_UUIDGEN */
#define HAVE_CLOCK_GETTIME 1
#define HAVE_CLOCK_GETTIME_DECL 1

/** pthread_np.h - non-portable stuff */
/* #undef HAVE_PTHREAD_NP_H */
/** pthread_setname_np(pthread_self(), "") - Linux */
/* #undef HAVE_PTHREAD_SETNAME_NP */
/** pthread_setname_np("") - OSX */
#define HAVE_PTHREAD_SETNAME_NP_1 1
/** pthread_set_name_np(pthread_self(), "") - *BSD */
/* #undef HAVE_PTHREAD_SET_NAME_NP */

/* #undef HAVE_PTHREAD_GETATTR_NP */
/* #undef HAVE_PTHREAD_ATTR_GET_NP */

#define HAVE_PTHREAD_GET_STACKSIZE_NP 1
#define HAVE_PTHREAD_GET_STACKADDR_NP 1

/* #undef HAVE_SETPROCTITLE */
#define HAVE_SETPROGNAME 1
#define HAVE_GETPROGNAME 1

/* #undef HAVE_MALLOC_INFO */

/*
 * Defined if ICU library has ucol_strcollUTF8 method.
 */
#define HAVE_ICU_STRCOLLUTF8 1

/*
* Defined if notifications on NOTIFY_SOCKET are enabled
 */
#define WITH_NOTIFY_SOCKET 1

/** \cond public */

/** System configuration dir (e.g /etc) */
#define SYSCONF_DIR "etc"
/** Install prefix (e.g. /usr) */
#define INSTALL_PREFIX ""
/** Build type, e.g. Debug or Release */
#define BUILD_TYPE "RelWithDebInfo"
/** CMake build type signature, e.g. Linux-x86_64-Debug */
#define BUILD_INFO "Darwin-arm64-RelWithDebInfo"
/** Command line used to run CMake */
#define BUILD_OPTIONS "cmake . -DCMAKE_INSTALL_PREFIX= -DENABLE_BACKTRACE=TRUE"
/** Compiler ID and version, assuming the C and C++ compiler IDs are equal. */
#define COMPILER_INFO "Clang-14.0.0.14000029"
/** C compile flags used to build Tarantool */
#define TARANTOOL_C_FLAGS " -fexceptions -funwind-tables -fasynchronous-unwind-tables -fno-common -Wformat -Wformat-security -Werror=format-security -fstack-protector-strong -fPIC -fmacro-prefix-map=/Users/gitlab_runner/builds/EjhsHZDe/0/picodata/devops/builder/tarantool-picodata=. -std=c11 -Wall -Wextra -Wno-gnu-alignof-expression -Wno-cast-function-type"
/** CXX compile flags used to build Tarantool */
#define TARANTOOL_CXX_FLAGS " -fexceptions -funwind-tables -fasynchronous-unwind-tables -fno-common -Wformat -Wformat-security -Werror=format-security -fstack-protector-strong -fPIC -fmacro-prefix-map=/Users/gitlab_runner/builds/EjhsHZDe/0/picodata/devops/builder/tarantool-picodata=. -std=c++11 -Wall -Wextra -Wno-invalid-offsetof -Wno-gnu-alignof-expression -Wno-cast-function-type"

/** A path to install *.lua module files */
#define MODULE_LIBDIR "/lib/tarantool"
/** A path to install *.so / *.dylib module files */
#define MODULE_LUADIR "/share/tarantool"
/** A path to Lua includes (the same directory where this file is contained) */
#define MODULE_INCLUDEDIR "/include/tarantool"
/** A constant added to package.path in Lua to find *.lua module files */
#define MODULE_LUAPATH "/usr/local/share/tarantool/?.lua;/usr/local/share/tarantool/?/init.lua;/share/tarantool/?.lua;/share/tarantool/?/init.lua;/usr/share/tarantool/?.lua;/usr/share/tarantool/?/init.lua;/usr/local/share/lua/5.1/?.lua;/usr/local/share/lua/5.1/?/init.lua;/share/lua/5.1/?.lua;/share/lua/5.1/?/init.lua;/usr/share/lua/5.1/?.lua;/usr/share/lua/5.1/?/init.lua"
/** A constant added to package.cpath in Lua to find *.so module files */
#define MODULE_LIBPATH "/usr/local/lib/tarantool/?.dylib;/lib/tarantool/?.dylib;/usr/lib/tarantool/?.dylib;/usr/local/lib/lua/5.1/?.dylib;/lib/lua/5.1/?.dylib;/usr/lib/lua/5.1/?.dylib"
/** Shared library suffix - ".so" on Linux, ".dylib" on Mac */
#define MODULE_LIBSUFFIX ".dylib"

/** \endcond public */

#define DEFAULT_CFG_FILENAME "tarantool.cfg"
#define DEFAULT_CFG SYSCONF_DIR "/" DEFAULT_CFG_FILENAME

/* #undef ENABLE_ASAN */

/* Cacheline size to calculate alignments */
#define CACHELINE_SIZE 64

/* #undef ENABLE_FLIGHT_RECORDER */
/* #undef ENABLE_TUPLE_COMPRESSION */
/* #undef ENABLE_SPACE_UPGRADE */
#define ENABLE_SSL 1
/* #undef ENABLE_AUDIT_LOG */
/* #undef ENABLE_FEEDBACK_DAEMON */
#define ENABLE_WAL_EXT 1
/* #undef ENABLE_READ_VIEW */
/* #undef ENABLE_SECURITY */
/* #undef ENABLE_COMPRESS_MODULE */

#define EXPORT_LIBCURL_SYMBOLS 1

/* #undef BUILD_STATIC */
/* #undef EMBED_LUAZLIB */
/* #undef EMBED_LUAZIP */
/* #undef EMBED_LUAROCKS */

/*
 * vim: syntax=c
 */
#endif /* TARANTOOL_CONFIG_H_INCLUDED */
